//+------------------------------------------------------------------+
//|                                                         Bolt.mq4 |
//|                                  Copyright 2007, Ralph Ronnquist |
//|                          mod by Kalenzo, http://www.fxservice.eu |
//+------------------------------------------------------------------+
#property copyright "Copyright 2007, Ralph Ronnquist"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LightGreen
#property indicator_color2 DarkOrange

double up[];
double dn[];

extern int range = 3;
extern int timeframe = 0; // Review time frame
extern int howManyLines = 10;
extern bool onlyLines = true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
    int index;

    IndicatorShortName( "Bolt(" + range + ")" );
    
    index = 0;
    SetIndexStyle( index, DRAW_ARROW );
    SetIndexBuffer( index, up );
    SetIndexLabel( index, "up" );
    SetIndexArrow( index, 108 );

    index = 1;
    SetIndexStyle( index, DRAW_ARROW );
    SetIndexBuffer( index, dn );
    SetIndexLabel( index, "dn" );
    SetIndexArrow( index, 108 );

    if ( timeframe == 0 )
        timeframe = Period();

    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
 
   int bip = howManyLines;
   int bim = howManyLines;
            
    for ( int bar = 0; bar <= Bars; bar++ ) {
    
           
  
         up[ bar ] = EMPTY_VALUE;
         dn[ bar ] = EMPTY_VALUE;
    
         if ( isPeriodHigh( bar, range ) )
         {
            if(!onlyLines)
            up[ bar ] = High[ bar ] + range * Point;
            
            if(bip>0)
            {
               drawLine("BOLT RES "+bip,Time[bar],Time[0], High[bar],High[bar],1,0,Lime,1);
               bip--;
            }   
            
         }   
         if ( isPeriodLow( bar, range ) )
         {
            if(!onlyLines)
            dn[ bar ] = Low[ bar ] - range * Point;
            
            if(bim>0)
            {
               drawLine("BOLT SUP "+bim,Time[bar],Time[0], Low[bar],Low[bar],1,0,Red,1);
               bim--;
            }
         }   
           
         
    }
    
    
    
    
    return(0);
    
}

// Returns true if the high is highest amongst the previous "range" bars
bool isPeriodHigh(int bar,int range)
{
    int tfbar = iBarShift( Symbol(), timeframe, Time[ bar ], false );
    
    for (int i = 1; i < range; i++) {
        if ( High[ bar ] <= iHigh( Symbol(), timeframe, tfbar+i ) )
            return( false );
    }
    return( true );
}

// Returns true if the low is lowest amongst the previos "range" bars
bool isPeriodLow(int bar,int range)
{
    int tfbar = iBarShift( Symbol(), timeframe, Time[ bar ], false );

    for (int i = 1; i < range; i++) {
        if ( Low[ bar ] >= iLow( Symbol(), timeframe, tfbar+i ) )
            return( false );
    }
    return( true );
}
//draws horizontal line
void drawLine(string name,datetime tfrom, datetime tto, double pfrom, double pto, int width, int ray, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, tfrom, pfrom,tto,pto);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else if(type == 2)
            ObjectSet(name, OBJPROP_STYLE, STYLE_DASHDOT);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
            ObjectSet(name,OBJPROP_RAY,ray);
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, tfrom, pfrom,tto,pto);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else if(type == 2)
            ObjectSet(name, OBJPROP_STYLE, STYLE_DASHDOT);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,width);
            ObjectSet(name,OBJPROP_RAY,ray);
          
         }
}
//+------------------------------------------------------------------+